//la matrice  la struttura di supporto in cui vengono manipolati i dati
import javax.swing.*;

	public class Matrice {
		public Elemento matrice[][];
			public Matrice() //il costruttore dichiara ed inizializza ogni casella della matrice di oggetti (Elemento)
			{
				matrice=new Elemento[5][6];
					for(int i=0;i<matrice.length;i++)
					{
						for(int j=0;j<matrice[0].length;j++)
						{
							matrice[i][j]=new Elemento(0,0);
						}
					}
			}
	
			public void inserisci(JPanel[][] griglia, int tmp)//metodo per l'inserimento delle cifre degli operandi nella matrice
			{
				//in base al contenuto della variabile tmp vengono inserite le cifre del primo o del secondo operando
				if(tmp==0) //inizializzazione del primo operando: prima riga della matrice
				{
					for(int i=0;i<4;i++)
						matrice[0][i+1]=new Elemento(0, Interface.getBoxValue(i)); 
				}
				else//inizializzazione del secondo operando: ultima colonna della matrice
				{
					for(int i=0;i<3;i++)
						matrice[i+1][5]=new Elemento(0, Interface.getBoxValue(4+i));
				}
			}
			public void calcola()   //calcola il prodotto
			{
				int rS=3, cS=5;
				//calcola i prodotti; (da notare che le operazioni di prodotto possono essere eseguite in parallelo
					while(rS>=0)
					{
						int rF=0, cF=4;
							while(cF>=0)
							{
								int prodotto = matrice[rF][cF].metaInf*matrice[rS][cS].metaInf;
								if(prodotto<10)
									matrice[rS][cF]=new Elemento(0,prodotto,0,prodotto); 
								else
									matrice[rS][cF]=new Elemento(prodotto/10 /*unit*/ ,prodotto%10 /*riporto*/ ,prodotto/10,prodotto%10 /*gli ultimi 2 parametri servono per identificare ed acquisire le immagini per le unit ed il riporto*/);
								cF--;
							}
						rS--;
					}
				
				//esegue le somme parziali; a differenza delle operazioni di prodotto, le operazioni di somma non possono essere eseguite in parallelo
				//poich si deve tener conto di eventuali riporti nelle somme parziali (le operazioni di somma dipendono l'una dall'altra)
				matrice[4][4].metaInf=matrice[3][4].metaInf;
				matrice[4][4].unita=matrice[3][4].metaInf;
				
				int num=matrice[2][4].metaInf+matrice[3][4].metaSup+matrice[3][3].metaInf;
				matrice[4][3].metaInf=num%10;
				matrice[4][3].unita=num%10;
				int tmpRip=num/10;
					
				num=matrice[1][4].metaInf+matrice[2][4].metaSup+matrice[2][3].metaInf+matrice[3][3].metaSup+matrice[3][2].metaInf;
				matrice[4][2].metaInf=(num+tmpRip)%10;
				matrice[4][2].unita=(num+tmpRip)%10;
				tmpRip=(num+tmpRip)/10;
					
				num=matrice[1][4].metaSup+matrice[1][3].metaInf+matrice[2][3].metaSup+matrice[2][2].metaInf+matrice[3][2].metaSup+matrice[3][1].metaInf;
				matrice[4][1].metaInf=(num+tmpRip)%10;
				matrice[4][1].unita=(num+tmpRip)%10;
				tmpRip=(num+tmpRip)/10;
					
				num=matrice[1][3].metaSup+matrice[1][2].metaInf+matrice[2][2].metaSup+matrice[2][1].metaInf+matrice[3][1].metaSup;
				matrice[3][0].metaInf=(num+tmpRip)%10;
				matrice[3][0].unita=(num+tmpRip)%10;
				tmpRip=(num+tmpRip)/10;
					
				num=matrice[1][2].metaSup+matrice[1][1].metaInf+matrice[2][1].metaSup;
				matrice[2][0].metaInf=(num+tmpRip)%10;
				matrice[2][0].unita=(num+tmpRip)%10;
				tmpRip=(num+tmpRip)/10;
				matrice[2][0].riporto=tmpRip;
					
				matrice[1][0].metaInf=matrice[1][1].metaSup+tmpRip;
				matrice[1][0].unita=matrice[1][1].metaSup+tmpRip;
				tmpRip=(matrice[1][0].metaInf)/10;
					for(int i=0;i<matrice.length;i++)
					{
						for(int j=0;j<matrice[0].length;j++)
						{
							System.out.print(matrice[i][j].getValue()+",");
							
						}
						System.out.println();
						System.out.println();
					}
					for(int i=0;i<matrice.length;i++)
					{
						for(int j=0;j<matrice[0].length;j++)
						{
							System.out.print(matrice[i][j].getRip()+",");
							
						}
						System.out.println();
					}
			}

			public Elemento[][] getMatrix()
			{
				return matrice;
			}
}
